/*
Module : EnumWnd.cpp
Purpose: Implementation for the main entry points for the EnumWnd DLL
Created: PJN / 20-01-2002

Copyright (c) 2002 - 2022 by PJ Naughter (Web: www.naughter.com, Email: pjna@naughter.com)

All rights reserved.

Copyright / Usage Details:

You are allowed to include the source code in any product (commercial, shareware, freeware or otherwise) 
when your product is released in binary form. You are allowed to modify the source code in any way you want 
except you cannot modify the copyright details at the top of each module. If you want to distribute source 
code with your application, then you are only allowed to distribute versions released by the author. This is 
to maintain a single distribution point for the source code. 

*/


//////////////////// Includes /////////////////////////////////////////////////

#include "stdafx.h"
#include "resource.h"
#pragma warning(push)
#pragma warning(disable: 28251)
#include "EnumWnd_i.h"
#pragma warning(pop)
#include "dllmain.h"
#include "EnumWindow.h"
#include "TopLevelWindows2.h"


//////////////////// Implementation ///////////////////////////////////////////

__control_entrypoint(DllExport) STDAPI DllCanUnloadNow()
{
  return _AtlModule.DllCanUnloadNow();
}

_Check_return_ STDAPI DllGetClassObject(_In_ REFCLSID rclsid, _In_ REFIID riid, _Outptr_ LPVOID FAR* ppv)
{
    return _AtlModule.DllGetClassObject(rclsid, riid, ppv);
}

#pragma warning(suppress: 28301)
__control_entrypoint(DllExport) STDAPI DllRegisterServer()
{
  return _AtlModule.DllRegisterServer();
}

#pragma warning(suppress: 28301)
__control_entrypoint(DllExport) STDAPI DllUnregisterServer()
{
  return _AtlModule.DllUnregisterServer();
}

STDAPI DllInstall(BOOL bInstall, _In_opt_  LPCWSTR pszCmdLine)
{
  HRESULT hr{E_FAIL};
  static const wchar_t* szUserSwitch{L"user"};

  if (pszCmdLine != nullptr) //NOLINT(clang-analyzer-optin.cplusplus.VirtualCall)
  {
    if (_wcsnicmp(pszCmdLine, szUserSwitch, wcslen(szUserSwitch)) == 0)
      ATL::AtlSetPerUserRegistration(true);
  }

  if (bInstall)
  {
    hr = DllRegisterServer();
    if (FAILED(hr))
      DllUnregisterServer();
  }
  else
    hr = DllUnregisterServer(); //NOLINT(clang-analyzer-optin.cplusplus.VirtualCall)

  return hr;
}
