/*
Module : TopLevelWindows.h
Purpose: Interface for class which implements the ITopLevelWindows interface
Created: PJN / 20-01-2002

Copyright (c) 2002 - 2022 by PJ Naughter (Web: www.naughter.com, Email: pjna@naughter.com)

All rights reserved.

Copyright / Usage Details:

You are allowed to include the source code in any product (commercial, shareware, freeware or otherwise) 
when your product is released in binary form. You are allowed to modify the source code in any way you want 
except you cannot modify the copyright details at the top of each module. If you want to distribute source 
code with your application, then you are only allowed to distribute versions released by the author. This is 
to maintain a single distribution point for the source code.

*/


//////////////////// Macros / Defines /////////////////////////////////////////

#pragma once


//////////////////// Includes /////////////////////////////////////////////////

#include "resource.h"
#pragma warning(push)
#pragma warning(disable: 28251)
#include "EnumWnd_i.h"
#pragma warning(pop)


//////////////////// Classes //////////////////////////////////////////////////

class ATL_NO_VTABLE CTopLevelWindows : public ATL::CComObjectRootEx<ATL::CComSingleThreadModel>,
                                       public ATL::CComCoClass<CTopLevelWindows, &CLSID_TopLevelWindows>,
                                       public ATL::IDispatchImpl<ITopLevelWindows, &__uuidof(ITopLevelWindows), &LIBID_ENUMWNDLib, 1, 0>
{
public:
//Constructors / Destructors
#pragma warning(suppress: 26455)
  CTopLevelWindows() = default;
  CTopLevelWindows(const CTopLevelWindows&) = delete;
  CTopLevelWindows(CTopLevelWindows&&) = delete;
  virtual ~CTopLevelWindows() = default;

#pragma warning(suppress: 26440)
DECLARE_REGISTRY_RESOURCEID(IDR_TOPLEVELWINDOWS)
DECLARE_NOT_AGGREGATABLE(CTopLevelWindows)

#pragma warning(suppress: 26434)
DECLARE_PROTECT_FINAL_CONSTRUCT()

#pragma warning(suppress: 26429 26440 26477 26481)
BEGIN_COM_MAP(CTopLevelWindows) //NOLINT(modernize-avoid-c-arrays, modernize-use-noexcept)
  COM_INTERFACE_ENTRY(ITopLevelWindows)
  COM_INTERFACE_ENTRY(IDispatch)
#pragma warning(suppress: 26477 26485)
END_COM_MAP()

//Non COM Methods
  CTopLevelWindows& operator=(const CTopLevelWindows&) = delete;
  CTopLevelWindows& operator=(CTopLevelWindows&&) = delete;
  static BOOL CALLBACK _EnumWindows(_In_ HWND hWnd, _In_ LPARAM lParam);
  BOOL EnumWindows(_In_ HWND hWnd);

//ITopLevelWindows
  STDMETHOD(Enumerate)();
  STDMETHOD(get__NewEnum)(IUnknown** ppVal);
  STDMETHOD(get_Count)(long* pVal);
  STDMETHOD(Item)(long nIndex, BSTR* pbstrTitle);

protected:
//Member variables
  ATL::CSimpleArray<HWND> m_hWnds;
};

#pragma warning(suppress: 26477)
OBJECT_ENTRY_AUTO(__uuidof(TopLevelWindows), CTopLevelWindows)
